<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="planEquityId"
          :columns="columns"
          :datasource="datasource"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'planName'">
              <a-tag color="orange">{{ record.planName }}</a-tag>
            </template>
            <template v-if="column.key === 'money'">
              <span>￥{{ record.money }}</span>
            </template>
            <template v-if="column.key === 'expirationTime'">
              <a-tag color="green">永久</a-tag>
            </template>
            <template v-if="column.key === 'nickname'">
              <a-tooltip :title="`${record.nickname} ${record.phone}`">
                <a-avatar :src="record.userAvatar" size="small" />
                <span style="padding-left: 3px">{{ record.nickname }}</span>
              </a-tooltip>
            </template>
            <template v-if="column.key === 'createTime'">
              <a-tooltip :title="`${toDateString(record.createTime)}`">
                {{ timeAgo(record.createTime) }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { computed, createVNode, ref, unref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { toDateString } from 'ele-admin-pro';
  import Search from './components/search.vue';
  import {
    pageUserPlanEquity,
    removeUserPlanEquity,
    removeBatchUserPlanEquity
  } from '@/api/love/plan-equity';
  import { timeAgo } from 'ele-admin-pro';
  import { useUserStore } from '@/store/modules/user';
  import type {
    UserPlanEquity,
    UserPlanEquityParam
  } from '@/api/love/plan-equity/model';
  import { useRouter } from 'vue-router';

  const userStore = useUserStore();
  // 当前用户信息
  const loginUser = computed(() => userStore.info ?? {});

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);
  const { currentRoute } = useRouter();
  // 表格选中数据
  const selection = ref<UserPlanEquity[]>([]);
  // 当前编辑数据
  const current = ref<UserPlanEquity | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({ page, limit, where, orders }) => {
    const { query } = unref(currentRoute);
    where.type = Number(query.type);
    return pageUserPlanEquity({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: '会员信息',
      dataIndex: 'nickname',
      width: 360,
      key: 'nickname'
    },
    {
      title: '权益名称',
      dataIndex: 'planName',
      key: 'planName'
    },
    {
      title: '到期时间',
      dataIndex: 'expirationTime',
      key: 'expirationTime'
    }
  ]);

  /* 搜索 */
  const reload = (where?: UserPlanEquityParam) => {
    console.log(where);
    console.log('sssssssss');
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: UserPlanEquity) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: UserPlanEquity) => {
    const hide = message.loading('请求中..', 0);
    removeUserPlanEquity(row.logId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchUserPlanEquity(
          selection.value.map((d) => {
            if (loginUser.value.userId === d.userId) {
              return d.planEquityId;
            }
          })
        )
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 判断是否过期 */
  const timeAfter = (text) => {
    return Date.parse(text) > new Date().getTime();
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  // const customRow = (record: UserPlanEquity) => {
  //   return {
  //     // 行点击事件
  //     onClick: () => {
  //       // console.log(record);
  //     },
  //     // 行双击事件
  //     onDblclick: () => {
  //       openEdit(record);
  //     }
  //   };
  // };

  query();
</script>

<script lang="ts">
  export default {
    name: 'UserPlanEquity'
  };
</script>

<style lang="less" scoped>
  .sys-org-table :deep(.ant-table-body) {
    overflow: auto !important;
    overflow: overlay !important;
  }

  .sys-org-table :deep(.ant-table-pagination.ant-pagination) {
    padding: 0 4px;
    margin-bottom: 0;
  }
</style>
